//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Global2.h"
#include "PrntSelPagesDlgs.h"
#include "RemailerDocs.h"
#include "PrintDlgs2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TPrntSelPagesDlg *PrntSelPagesDlg;
//---------------------------------------------------------------------------

void __fastcall PrintSelectedPages(TQSStatsWin4 *Owner, TTabControl *TabSet)
{
   PrntSelPagesDlg = new TPrntSelPagesDlg(Owner, TabSet);
   PrntSelPagesDlg->PageList->Color = Owner->SourceBox->Color;
   PrntSelPagesDlg->Font->Assign(Owner->Font);
   PrntSelPagesDlg->ShowModal();

   delete PrntSelPagesDlg;
}
//---------------------------------------------------------------------------

__fastcall TPrntSelPagesDlg::TPrntSelPagesDlg(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

__fastcall TPrntSelPagesDlg::TPrntSelPagesDlg(TComponent* Owner, TTabControl *tabset)
        : TForm(Owner)
{
   TabSet = tabset;
   HasSelectedText = false;
   for (int i = 0; i < TabSet->Tabs->Count; i++)
   {
      PageList->Items->Add(TabSet->Tabs->Strings[i]);
      if (TabEditor(i)->SelLength > 0)
         HasSelectedText = true;
   }
   SelectedText->Enabled = HasSelectedText;
   if (SelectedText->Enabled)
   {
      SelectedText->Checked = true;
      SelectedTextClick(NULL);
      for (int i = 0; i < PageList->Items->Count; i++)
         PageList->Checked[i] = true;
   }
}
//---------------------------------------------------------------------------

void __fastcall TPrntSelPagesDlg::AllTextClick(TObject *)
{
   PageList->Items->BeginUpdate();
   PageList->Clear();

   for (int i = 0; i < TabSet->Tabs->Count; i++)
      PageList->Items->Add(TabSet->Tabs->Strings[i]);

   PageList->Items->EndUpdate();
}
//---------------------------------------------------------------------------

void __fastcall TPrntSelPagesDlg::SelectedTextClick(TObject *)
{
   PageList->Items->BeginUpdate();
   PageList->Clear();

   for (int i = 0; i < TabSet->Tabs->Count; i++)
      if (TabEditor(i)->SelLength > 0)
         PageList->Items->Add(TabSet->Tabs->Strings[i]);

   PageList->Items->EndUpdate();
}
//---------------------------------------------------------------------------

TRichEdit *__fastcall TPrntSelPagesDlg::TabEditor(int tab)
{
   assert(tab >= 0 && tab < TabSet->Tabs->Count);
   TRemailerDoc *doc = (TRemailerDoc*)TabSet->Tabs->Objects[tab];
   return doc->ed;
}
//---------------------------------------------------------------------------

void __fastcall TPrntSelPagesDlg::FormCloseQuery(TObject *, bool &)
{
   if (ModalResult == mrOk)
   {
      int pages = PageList->Items->Count;
      for (int i = 0; i < pages; i++)
      {
         if (PageList->Checked[i])
         {

            int index = TabSet->Tabs->IndexOf(PageList->Items->Strings[i]);
            assert(index >= 0);

            TRichEdit *editor = TabEditor(index);
            AnsiString docname = TabSet->Tabs->Strings[index];

            TStringList *text = new TStringList();
            if (AllText->Checked)
               text->Text = editor->Lines->Text;
            else
               text->Text = editor->SelText;

            PrintDocument(this, docname, text, editor->Font);
            //if (i < pages - 1)
               Snooze(500);
         }
      }
   }
}
//---------------------------------------------------------------------------

